
#ifdef NDBM
#include <fcntl.h>
#include <ndbm.h>
#endif

#ifdef TDBM
#include "tdbm.h"
#endif

/*
 * Copyright 1992 Barry Brachman
 * See included file "copyright.h" for complete copyright information.
 */

#include <stdio.h>

char valbuf[1024];
char keybuf[100];

main()
{
	int n;

#ifdef NDBM
	datum key, value;
	DBM *dbm;

	dbm = dbm_open("/tmp/dbm", O_RDWR | O_CREAT | O_EXCL, 0600);
	if (dbm == NULL) {
		fprintf(stderr, "dbm_open failed.\n");
		exit(1);
	}
#endif

#ifdef TDBM
	Datum key, value;
	Dbm *dbm;
	DbmFileType type;
	Tid *tid;

	if (DbmBegin(NULL, &tid) != DBM_OK) {
		fprintf(stderr, "DbmBegin failed.\n");
		exit(1);
	}
#ifdef MEM
	type = DBM_VOLATILE;
#else
	type = DBM_PERSISTENT;
#endif
	if (DbmOpen("/tmp/dbm", type, NULL, &dbm, NULL) != DBM_OK) {
		fprintf(stderr, "DbmOpen failed.\n");
		exit(1);
	}
#endif

	n = 1;
	while (gets(valbuf) != NULL) {
		sprintf(keybuf, "%d", n++);
		key.dptr = keybuf;
		key.dsize = strlen(keybuf);
		value.dptr = valbuf;
		value.dsize = strlen(valbuf) + 1;
#ifdef NDBM
		if (dbm_store(dbm, key, value, DBM_INSERT) < 0) {
#endif
#ifdef TDBM
		if (DbmStore(dbm, tid, key, value, DBM_INSERT) != DBM_OK) {
#endif
			fprintf(stderr, "dbm_store failed.\n");
			exit(1);
		}
	}
#ifdef TDBM
	if (DbmCommit(tid) != DBM_OK) {
		fprintf(stderr, "DbmCommit failed.\n");
		exit(1);
	}
#endif
	exit(0);
}

