static char *SCCS_Id = "@(#)close.c\tver 1.1 (92/05/11 15:51:18)";

/*
 * Copyright 1992 Barry Brachman
 * See included file "copyright.h" for complete copyright information.
 */

#include <stdio.h>

#include "local.h"

DbmRc
DbmClose PARAMS((dbm),
Dbm *dbm)
{
	DbmFile *dbf;
	DbmRc rc;

	dbf = dbm->dbmfile;
	rc = DBM_OK;


	/* All uncommitted transactions for this dbm are explicitly aborted. */
	if ((rc = TransTerminate(dbm, DBM_ABORT)) != DBM_OK)
		return(rc);

	if (--dbf->open_count == 0) {

		/* Last close */
		if (dbf->persistent) {
			if (fsync(dbf->fd) < 0)
				rc = DBM_FSYNC_FAILED;
			/* Implicitly unlocks the file */
			if (CLOSE(dbf->fd) < 0)
				rc = DBM_CLOSE_FAILED;
		}
		TransUncache(dbf);
		RemoveFromDbflist(dbf);			/* Also frees it. */
	}

	FREE(dbm);
	return(rc);
}
