
#include <stdio.h>

#include "tdbm.h"

#define ERR(rc)		if (rc != DBM_OK) printf("%s\n", DbmErrorString(rc))
#define FATAL(rc)	if (rc != DBM_OK) printf("%s\n", DbmErrorString(rc)), exit(1)

main(argc, argv)
int argc;
char **argv;
{
	char buf[100];
	Datum key, value;
	Dbm *dbm;
	DbmRc rc;
	DbmRecovery *recovery;
	DbmTidName tidname;
	Tid *tid, *tid2;

	rc = DbmOpen("db/gorp", DBM_PERSISTENT, NULL, &dbm, &recovery);
	ERR(rc);

	if (recovery) {
		while (recovery) {
			printf("There is something to recover.\n");
			rc = DbmRecover(dbm, &recovery, &tid);
			FATAL(rc);

			sprintf(buf, "%d.%d.%d",
				tid->active->tid_name.hostid, tid->active->tid_name.start_time,
				tid->active->tid_name.count);
			printf("Tidname = %s\n", buf);
#ifdef NOTDEF
			key.dptr = buf;
			key.dsize = strlen(buf) + 1;
			rc = DbmFetch(dbm, tid, key, &value);
			ERR(rc);
			printf("Value = %s\n", value.dptr);
#endif
			rc = DbmCommit(tid);
			FATAL(rc);
		}
	}
	else
		printf("There is nothing to recover.\n");

	if (argc > 1) {
		key.dptr = "one";
		key.dsize = 4;
		value.dptr = "1";
		value.dsize = 2;
		rc = DbmBegin(NULL, &tid);
		ERR(rc);
		rc = DbmStore(dbm, tid, key, value, DBM_REPLACE);
		ERR(rc);

		rc = DbmPrecommit(tid, &tidname);
		ERR(rc);

		sprintf(buf, "%d.%d.%d",
			tidname.hostid, tidname.start_time, tidname.count);
		printf("Tidname = %s\n", buf);

/* #ifdef NOTDEF
*/
		rc = DbmBegin(NULL, &tid2);
		key.dptr = buf;
		key.dsize = strlen(buf) + 1;
		value.dptr = "OK";
		value.dsize = 3;
		rc = DbmStore(dbm, tid2, key, value, DBM_REPLACE);
		ERR(rc);
		rc = DbmCommit(tid2);
		ERR(rc);
/* #endif
*/

		rc = DbmCommit(tid);
		ERR(rc);
	}
	else {
		key.dptr = "one";
		key.dsize = 4;
		rc = DbmBegin(NULL, &tid);
		ERR(rc);
		rc = DbmFetch(dbm, tid, key, &value);
		ERR(rc);
		rc = DbmCommit(tid);
		ERR(rc);
		printf("value: '%s' (len=%d)\n", value.dptr, value.dsize);
	}
}

