/* SCCS_Id = "@(#)threads.h\tver 1.3 (92/08/25 15:19:38)" */

#ifndef _DBM_THREADS_H_
#define _DBM_THREADS_H_

#include "ansi.h"

#ifdef THREADS
#include "threads/os.h"

#define ALLOW_MULTIPLE_CHILDREN	1

#define CLOSE(X)            	Close(X)
#define OPEN(X,Y,Z)         	Open(X,Y,Z)
#define READ(X,Y,Z)         	Read(X,Y,Z)
#define WRITE(X,Y,Z)        	Write(X,Y,Z)

#define FREE(X)             	Free(X)
#define MALLOC(X)           	Malloc(X)
#define NAMEDMALLOC(N,X)       	NamedMalloc(N,X)
#define REALLOC(X,N)        	Realloc(X,N)
#define STRDUP(P)				Strdup(P)

extern char *Strdup PROTO((char *p));
#else

#define NLOCKS		100
typedef enum { LOCK_READMODE, LOCK_WRITEMODE } LOCKMODE;

#define CLOSE(X)            close(X)
#define OPEN(X,Y,Z)         open(X,Y,Z)
#define READ(X,Y,Z)         read(X,Y,Z)
#define WRITE(X,Y,Z)        write(X,Y,Z)

#define FREE(X)             free(X)
#define MALLOC(X)           malloc(X)
#define NAMEDMALLOC(N,X)    malloc(X)
#define REALLOC(X,N)        realloc(X,N)
#define STRDUP(P)			strdup(P)

extern char *strdup PROTO((char *));
extern int FreeLock PROTO((int));
extern int NewLock PROTO((void));
extern int ReadLock PROTO((int, int (*)(), void *));
extern int SeekNRead PROTO((int fd, char *buf, int len, off_t offset,
								int mode));
extern int SeekNWrite PROTO((int fd, char *buf, int len, off_t offset,
								int mode));
extern void ShowLocks PROTO((void));
extern int Unlock PROTO((int));
extern int UpgradeLock PROTO((int, int (*)(), void *));
extern int WriteLock PROTO((int, int (*)(), void *));
#endif

#endif
